
rail_pictures_internal_cr = function(elems)
  local keys = {{"straight_rail", "horizontal", 64, 64, 0, 0},
                {"straight_rail", "vertical", 64, 64, 0, 0},
                {"straight_rail", "diagonal-left-top", 64, 64, 0, 0},
                {"straight_rail", "diagonal-right-top", 64, 64, 0, 0},
                {"straight_rail", "diagonal-right-bottom", 64, 64, 0, 0},
                {"straight_rail", "diagonal-left-bottom", 64, 64, 0, 0},
                {"curved_rail", "vertical-left-top", 128, 256, 0, 0},
                {"curved_rail", "vertical-right-top", 128, 256, 0, 0},
                {"curved_rail", "vertical-right-bottom", 128, 256, 0, 0},
                {"curved_rail", "vertical-left-bottom", 128, 256, 0, 0},
                {"curved_rail" ,"horizontal-left-top", 256, 128, 0, 0},
                {"curved_rail" ,"horizontal-right-top", 256, 128, 0, 0},
                {"curved_rail" ,"horizontal-right-bottom", 256, 128, 0, 0},
                {"curved_rail" ,"horizontal-left-bottom", 256, 128, 0, 0}}
  local res = {}
  for _ , key in ipairs(keys) do
    local part = {}
    dashkey = key[1]:gsub("_", "-")
    for _ , elem in ipairs(elems) do
      part[elem[1]] =
      {
        filename = string.format("__concreted-rails__/graphics/entity/%s/%s-%s-%s.png", dashkey, dashkey, key[2], elem[2]),
        priority = elem.priority or "extra-high",
        flags = elem.mipmap and { "icon" } or { "low-object" },
        width = key[3],
        height = key[4],
        shift = {key[5], key[6]},
        variation_count = (key[7] and elem.variations) or 1,
        hr_version =
        {
          filename = string.format("__concreted-rails__/graphics/entity/%s/%s-%s-%s.png", dashkey, dashkey, key[2], elem[2]),
          priority = elem.priority or "extra-high",
          flags = elem.mipmap and { "icon" } or { "low-object" },
          width = key[3],
          height = key[4],
          shift = {key[5], key[6]},
          scale = 1,
          variation_count = (key[7] and elem.variations) or 1,
        }
      }
    end
    dashkey2 = key[2]:gsub("-", "_")
    res[key[1] .. "_" .. dashkey2] = part
  end
    res["rail_endings"] = {
    sheets =
    {
      {
        filename = "__concreted-rails__/graphics/entity/rail-endings/rail-endings-background.png",
        priority = "high",
        flags = { "low-object" },
        width = 128,
        height = 128,
        hr_version = {
          filename = "__concreted-rails__/graphics/entity/rail-endings/rail-endings-background.png",
          priority = "high",
          flags = { "low-object" },
          width = 128,
          height = 128,
          scale = 1
        }
      },
      {
        filename = "__concreted-rails__/graphics/entity/rail-endings/rail-endings-metals.png",
        priority = "high",
        flags = { "icon" },
        width = 128,
        height = 128,
        hr_version = {
          filename = "__concreted-rails__/graphics/entity/rail-endings/rail-endings-metals.png",
          priority = "high",
          flags = { "icon" },
          width = 128,
          height = 128,
          scale = 1
        }
      }
    }
  }
  return res
end 

rail_pictures_cr = function()
  return rail_pictures_internal_cr({
                                {"metals", "metals", mipmap = true},
                                {"backplates", "backplates", mipmap = true},
                                {"ties", "ties"},
                                {"stone_path", "stone-path"},
                                {"segment_visualisation_middle", "segment-visualisation-middle"},
                                {"segment_visualisation_ending_front", "segment-visualisation-ending-1"},
                                {"segment_visualisation_ending_back", "segment-visualisation-ending-2"},
                                {"segment_visualisation_continuing_front", "segment-visualisation-continuing-1"},
                                {"segment_visualisation_continuing_back", "segment-visualisation-continuing-2"}
                              })
end          

local concrete_straight_rail = table.deepcopy(data.raw["straight-rail"]["straight-rail"])
concrete_straight_rail.name = "concrete-straight-rail"
concrete_straight_rail.icon = "__concreted-rails__/graphics/icons/concrete-straight-rail.png"
concrete_straight_rail.minable.result = "concrete-rail"
concrete_straight_rail.pictures = rail_pictures_cr()

local concrete_curved_rail = table.deepcopy(data.raw["curved-rail"]["curved-rail"])
concrete_curved_rail.name = "concrete-curved-rail"
concrete_curved_rail.icon = "__concreted-rails__/graphics/icons/concrete-curved-rail.png"
concrete_curved_rail.minable.result = "concrete-rail"
concrete_curved_rail.pictures = rail_pictures_cr()
concrete_curved_rail.placeable_by.item = "concrete-rail"

data:extend({
  concrete_straight_rail,
  concrete_curved_rail
})
